#include <iostream>
#include <fstream>
#include <vector>
#include <set>
#include <algorithm>
using namespace std;

const int MAXN = 200005;

ifstream inp, sol, out;

int n, m, t[MAXN];
long long k[MAXN];

int main(int argc, char *argv[])
{
    inp.open(argv[1]);
    sol.open(argv[2]);
    out.open(argv[3]);

    inp >> n >> m;
    for (int i = 1; i <= n; ++ i)
    {
        inp >> t[i] >> k[i];
    }
    inp.close();

    int jury;
    sol >> jury;
    sol.close();

    int part;
    out >> part;

    if (!out.good() or part != jury)
    {
        cout << 0 << endl;
        cerr << "Wrong answer" << endl;
        return 0;
    }

    set<int> s;
    vector<pair<int, long long>> v;

    for (int i = 1; i <= part; ++ i)
    {
        int x;
        out >> x;
        s.insert(x);

        if (!out.good() or x < 1 or x > n or s.size() != i)
        {
            cout << 0 << endl;
            cerr << "Wrong answer" << endl;
            return 0;
        }

        v.emplace_back(t[x], k[x]);
    }

    sort(v.begin(), v.end());

    long long sum = 0;
    for (int i = 0; i < v.size(); ++ i)
    {
        sum += v[i].second;
        if (sum > 1LL * m * v[i].first)
        {
            cout << 0 << endl;
            cerr << "Wrong answer" << endl;
            return 0;
        }
    }

    cout << 1 << endl;
    cerr << "Correct answer" << endl;
    return 0;
}
